Subject: Re: [PATCH net-next] net: pse-pd: tps23881: Fix the device ID check

From: Kyle Swenson <[email-masked]>
Date: Tue, 30 Jul 2024 21:52:49 +0000

Hello Thomas,

On Tue, Jul 30, 2024 at 06:18:12PM +0200, Thomas Petazzoni wrote:
> Hello Kyle,
> 
> On Tue, 30 Jul 2024 16:11:08 +0000
> Kyle Swenson <[email-masked]> wrote:
> 
> > The DEVID register contains two pieces of information: the device ID in
> > the upper nibble, and the silicon revision number in the lower nibble.
> > The driver should work fine with any silicon revision, so let's mask
> > that out in the device ID check.
> > 
> > Fixes: 20e6d190ffe1 ("net: pse-pd: Add TI TPS23881 PSE controller driver")
> > Signed-off-by: Kyle Swenson <[email-masked]>
> > ---
> >  drivers/net/pse-pd/tps23881.c | 2 +-
> >  1 file changed, 1 insertion(+), 1 deletion(-)
> > 
> > diff --git a/drivers/net/pse-pd/tps23881.c b/drivers/net/pse-pd/tps23881.c
> > index 61f6ad9c1934..bff8402fb382 100644
> > --- a/drivers/net/pse-pd/tps23881.c
> > +++ b/drivers/net/pse-pd/tps23881.c
> > @@ -748,11 +748,11 @@ static int tps23881_i2c_probe(struct i2c_client *client)
> >  
> >  	ret = i2c_smbus_read_byte_data(client, TPS23881_REG_DEVID);
> >  	if (ret < 0)
> >  		return ret;
> >  
> > -	if (ret != 0x22) {
> > +	if ((ret & 0xF0) != 0x20) {
> 
> Thanks for the patch! I believe it would make sense to use defines
> here. At least for 0xF0, and perhaps for 0x20 as well.
> 
> Maybe:
> 
> #define TPS23881_REG_DEVID      		0x43
> #define TPS23881_REG_DEVID_DEVID_MASK		0xF0
> #define TPS23881_REG_DEVID_DEVID_VAL		0x2

Ah, yes, I agree.  I'll make the changes and send out a V2 tomorrow.

> 
> and then:
> 
> 	if (FIELD_GET(TPS23881_REG_DEVID_DEVID_MASK, ret) != 
>             TPS23881_REG_DEVID_DEVID_VAL)
> 
> (totally untested, of course)
> 
> Best regards,
> 
> Thomas
> -- 
> Thomas Petazzoni, co-owner and CEO, Bootlin
> Embedded Linux and Kernel engineering and training
> https://bootlin.com

Thanks so much for the review!

Cheers,
Kyle